#!/bin/sh

echo -e "\nWelcome to the tiny configurator of kernsh-0.2c"
echo "=================================================="
echo -e "\nShould work on a 2.2 and 2.4 kernels"
echo -e "Never forget that you are the ultimate tool :)"
echo

SRC="/lib/modules/\$(KV)/build"
echo "If I where you, I will change this line only if You need a kernsh version"
echo "for one kernel, If you want to be able to compile against many kernel "
echo "without reconfiguring, It should work as is :)"
read -p "Where are your kernel sources located ? [$SRC] " KSRC
case $KSRC in
	"")
		IFLAGS=-I$SRC/include
		;;
	*)
		IFLAGS=-I$KSRC/include
		;;
esac

#echo -n "Checking for RH systems : "
#if [ -e /etc/redhat-release -o -e /etc/redhat_release ];
#then
#	echo "Yes"
#	read -p "Do you use a kernel from RH ? [Y/n] " KRH
#	case $KRH in
#		n|N|No|no)
#			;;
#		*)
#			CFLAGS=-D_RH_
#			;;
#	esac
#else
#	echo "No"
#fi

LIB=termcap

read -p "Do you use the termcap or ncurses library ? [$LIB] " KLIB
case $KLIB in
	"")
		LFLAGS=-l$LIB
		;;
	*)
		LFLAGS=-l$KLIB
		;;
esac

read -p "Do you want to do debugging (valgrind for example) ? [y/N] " KDEB
case $KDEB in
	Y|y|yes|Yes)
		CFLAGS="$CFLAGS -g -ggdb -DDEBUG"
		echo "WARNING !!! Don't report  Bugs when using these flags !!"
		echo "All the idt stuff will be not  functionnal with the -DDEBUG"
		echo "Flag ! ( if you want only -g -ggbb edit Makefile.in )"
		sleep 2
		;;
	*)
		CFLAGS="$CFLAGS -fomit-frame-pointer -O2 -pipe"
		;;
esac

read -p "Do you want a fascist compilation (-Werror -Wuninitialized) ? [y/N] " FAS
case $FAS in
	Y|y|yes|Yes)
		CFLAGS="$CFLAGS -Werror -Wuninitialized"
		echo "WARNING !!! Don't report Bugs concerning the compilation"
		echo "If you don't understand what this Flag implies !!!"
		sleep 2
		;;
	*)
		;;
esac

echo -n "Checking gcc version ..."
#This is temporary, Because lot's of kernel headers are broken :/
#Was using -fno-strict-aliasing, needed now only for modules
GCCV1=`gcc --version | grep 3.3`
GCCV2=`echo $GCCV1 | grep gcc | cut -d \  -f 3`
case $GCCV1 in
	3.3*)
		CFLAGS="$CFLAGS -DGCC33"
		;;
	*)
		case $GCCV2 in
			3.3*)
				CFLAGS="$CFLAGS -DGCC33"
				;;
			*)
				;;
		esac
		;;
esac

echo " Done"
echo

#add the build include file in the IFLAGS ?
BUILD="`pwd`/=build/\$(KV)"
IFLAGS="$IFLAGS -I$BUILD/obj"

echo -n "Writing Makefile.in : "
echo -e "CFLAGS =\t$CFLAGS" > Makefile.in
echo -e "LFLAGS =\t$LFLAGS" >> Makefile.in
echo -e "KV     =\t\$(shell uname -r)" >> Makefile.in
echo -e "IFLAGS =\t$IFLAGS" >> Makefile.in
echo -e "BUILD  =\t`pwd`/=build/\$(KV)" >> Makefile.in
echo "Done"

echo -e "\nNow you can compile kernsh with make"
echo "Thank you for using kernsh and happy hunting !"

exit 0

