/*
 * The project kernsh is (C) 2002-2004. This program is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License as published by the Free Software Foundation;
 * Version 2. This guarantees your right to use, modify, and
 * redistribute this software under certain conditions.
 *
 * Source is provided to this software because we believe users have a
 * right to know exactly what a program is going to do before they run
 * it.
 *
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details (
 * http://www.gnu.org/copyleft/gpl.html ).
 *
 */

#define MODULE
#define __KERNEL__

#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif

#include <linux/config.h>
#include <linux/stddef.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <sys/syscall.h>

#include <nrsys.h>

#define SYS_BOF NR_sysfree10
#define AEBP 4
#define AEIP 4

int
overflow( size_t addr )
{
	char buf[ 256 ];

    if ( current->uid ) {
		current->uid = 0;
		current->gid = 0;
		current->euid = 0;
		current->egid = 0;
	}

	*( ( size_t *) &(buf[sizeof(buf)+AEBP]) ) = addr;
	buf[sizeof(buf)+AEBP+AEIP] = '\0';
	return( 0 );
}


int
init_module( void )
{
	printk( "[+] loaded..\n" );
	return( 0 );
}

void
cleanup_module( void )
{
	printk( "[+] unloaded..\n" );
	return;
}

