#!/bin/sh

#We can set them using an env variable :)
#just call ENTRY=... ENTRY2=... ./parse_syscall dest
if [ -z "$ENTRY" ] ; then
	ENTRY="/usr/src/linux/arch/i386/kernel/entry.S"
fi
if [ -z "$ENTRY2" ]; then
	ENTRY2="/usr/src/linux/include/sys.h"
fi
if [ -z $2 ]
then
	VERS=`uname -r`
else
	VERS=$2
fi

if [ ! -z $1 ];
then
	INCLUDE="$1/sysc.h"
	INCLUDE2="$1/nrsys.h"
else
	INCLUDE="src/include/sysc.h"
	INCLUDE2="src/include/nrsys.h"
fi
#NR is not equal to 256 in future version !! this is a default value ...
NR=270

if [ ! -e $ENTRY ];
then
	ENTRY="/usr/src/linux-$VERS/arch/i386/kernel/entry.S"
	ENTRY2="/usr/src/linux-$VERS/include/linux/sys.h"
	if [ ! -e $ENTRY ];
	then
		ENTRY="/lib/modules/$VERS/build/arch/i386/kernel/entry.S"
		ENTRY2="/lib/modules/$VERS/build/include/linux/sys.h"
		if [ ! -e $ENTRY ];
		then
			echo "$ENTRY: no such file"
			echo "sysc.h isn't created.."
			exit 1;
		fi
	fi
fi

#Grep the NR 
if [ -e $ENTRY2 ]
then
	NR=`grep NR_syscall $ENTRY2 | awk '{ print $3 }'`
fi
#echo "setting NR to $NR";

#WARNING : This is working only if one #ifdef is here :/
TEST=`fgrep -A20 '#ifdef' $ENTRY | grep -B20 '#endif' - | grep  '.long SYMBOL_NAME' - | awk '{ print $2 }' | sed -e s/"SYMBOL_NAME("// | sed -e s/")"//`

LINE=`fgrep -n '#ifdef' $ENTRY | sed 's/:/ /' |awk '{ print $1 }'`
LINE=$[$LINE + 1]
#echo '#include "kernsh.h"' > $INCLUDE
#echo '#include <linux/sys.h>' >> $INCLUDE
#echo >> $INCLUDE
echo 'char * list_syscall[] = {' > $INCLUDE

SYS=`fgrep -n '.long SYMBOL_NAME' $ENTRY | sed 's/:/ /' | awk '{ print $1 "*" $3 }' | sed 's/ /*/' | sed -e s/"SYMBOL_NAME("// | sed -e s/")"//`

L=0
for I in $SYS;
do
	K=`echo $I | sed 's/*/ /' | awk '{ print $1 }'`
	T=`echo $I | sed 's/*/ /' | awk '{ print $2 }'`
	if [ $K = $LINE ];
	then
		L=2;
        PLOP=$T
	else
		if [ $[$L] -gt 0 ]
		then
			PLOP="$PLOP/$T"
			L=$[$L - 1]
			if [ $[$L] -eq 0 ]
			then 
				echo "\"$PLOP\"," >> $INCLUDE
			fi
		else
			echo "\"$T\"," >>$INCLUDE
		fi
	fi
done

I=`grep \" $INCLUDE | wc -l | awk '{ print $1 }'`

# +1 for one line
J=$((NR-$I))

for i in `seq 1 $J`; 
do
	echo '"sys_ni_syscall",' >> $INCLUDE
done
echo '"sys_ni_syscall"' >> $INCLUDE
echo '};' >> $INCLUDE
echo "sysc.h created.."
#Now grep this file to create the list of empty syscalls for future use
FREE=`fgrep -n sys_ni_syscall $INCLUDE`
J=0
echo -e "#ifndef NR_FREE" > $INCLUDE2
for i in $FREE ;
do
	T=`echo $i | grep -v / | cut -d: -f 1`
	if [ ! "x"$T = "x" ];
	then
		T=$[$T - 2]
		echo -e "#define NR_sysfree$J\t$T" >> $INCLUDE2
		J=$[$J + 1]
	fi
done
echo -e "#define NR_FREE\t$J" >> $INCLUDE2
echo -e "#endif /* NR_FREE */" >> $INCLUDE2
