/*
 * The project kernsh is (C) 2002-2004. This program is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License as published by the Free Software Foundation;
 * Version 2. This guarantees your right to use, modify, and
 * redistribute this software under certain conditions.
 *
 * Source is provided to this software because we believe users have a
 * right to know exactly what a program is going to do before they run
 * it.
 *
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details (
 * http://www.gnu.org/copyleft/gpl.html ).
 *
 */

/* Adaptation to kernsh by Kstat _ At _ kernsh doT org
 * License GPL v2 (Thanks Mayhem :)
 *
 * I let you know that there is "bugs" in Discrete mode for some functions
 * I first meet them with the kernsh implementation, so I was thinking that 
 * I was wrong :). But after testing it with the native lib (LKH) I found 
 * the same bugs ... So was not me :D. If you are able to correct them, please
 * tell us. (We definitively needs an asm GURU :/).
 *
 * An example of function not working : tcp_get_info ...
 * 
 */
/*
**
** LKH !%$@# 
**
** Just #include "lkh.c" in your lkm .
**
** Made by <mayhem@hert.org>
**
** Last update Fri Jan 18 17:44:59 2002 mayhem
**
*/
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "include/lkh.h"
#include "include/kernsh.h"

struct Slot_hook * slot_hook[SLOT_MAX]; /* (was)Chained list of slot_hook */
int num_slot = -1;

int debug_hook = 0;

void * 
wr_memcpy(void * addr,const void * what,size_t s_what) {
	if ( debug_hook == 0 ) {
		write_kmem((char *)what,(size_t)addr,s_what,file_descriptor_kmem);
	} else {
		hexdump((char *)what,s_what,(unsigned long)addr);
	}	
	return (void *)NULL;
}

/*
** ADD A CALLBACK FOR THAT HOOK
** -> hook_functions_list[range] = new_routine;
*/
int	lkh_khook_add_entry(struct Uhook_t *h, int new_routine, int range)
{
  int	off;

  if (range < 0 && range > 7)
    return (-1);
  
  h->h.hook[INTRO_CODE_SIZE + range * 5] = CALL;

  /*
  ** Calculate relative offset for our call instruction
  ** then copy it in the code .
  */
  off = (int) new_routine - ((int) h->addr_h +
    ((int) ((char *) &h->h.hook[INTRO_CODE_SIZE + 5 + range * 5]) - (unsigned int)&h->h));
  *(int *) &h->h.hook[INTRO_CODE_SIZE + 1 + range * 5] = off;
  wr_memcpy((char *)h->addr_h,(void *)&h->h,sizeof(h->h));
  return (0);

}

/*
** DELETE A CALLBACK FOR THAT HOOK
** -> remove an entry , placing five NOP's (overwriting the call) 
** in the requested slot .
*/
int	lkh_khook_remove_entry(struct Uhook_t *h, int range)
{
  if (range < 0 && range > 7)
    return (-1);
  memset(&h->h.hook[INTRO_CODE_SIZE + range * 5], NOP, 5);
  wr_memcpy((char *)h->addr_h,(char *)&h->h,sizeof(h->h));
  return (0);
}

/*
** remove all callback for that hook
*/
void	lkh_khook_purge(struct Uhook_t *h)
{
  memset(&h->h.hook[INTRO_CODE_SIZE], NOP, 40);
  wr_memcpy((char *)h->addr_h,(char *)&h->h,sizeof(h->h));
}

/*
** Destroy a kernel hook
*/
void	lkh_khook_destroy(struct Uhook_t *h)
{
  lkh_khook_set_state(&(h->h), HOOK_DISABLED);
  kkfree(h->addr_h);
}

/*
** Create a kernel hook and set its attributes
**
** Hook the function putting an indirect jump instruction pointing to 
** the hook code .
** Since we have to overwrite the function 's code beginning , 7 bytes are
** saved .
**
** The hijacked function is still called, but after the hook code 
** Check the asmcode() function for human readable code ;)
**
** The hook can be set for functions with o without stack frame pointer
**
*/
struct Uhook_t		*lkh_khook_create(int hooked, int mask)
{
  int		tmp;
  struct Uhook_t *uhook_t= (struct Uhook_t *)malloc(sizeof(struct Uhook_t));
  char		buf[BUFSIZ];
  char		hook_code[] = 
    "\xBE\x00\x00\x00\x00"	/* movl $0x00, %esi	*/
				/* 1ST RELOCATION (&saved_bytes[0], absolute) */
    "\xBF\x00\x00\x00\x00"	/* movl $0x00, %edi	*/
				/* 2ND RELOCATION (hijack_me absolute offset) */
    "\x1E"			/* push %ds		*/
    "\x07"			/* pop  %es		*/
    "\xFC"			/* cld			*/
    "\x31\xC9"			/* xor %ecx, %ecx	*/
    "\xB1\x07"			/* movl $0x07, %cl	*/
    "\xF3\xA4"			/* rep movsb		*/

    "\x8D\x44\x24\x08"		/* leal 8(%esp), %eax	*/
    "\x50"			/* push %eax		*/
    "\x90\x90\x90\x90\x90"	/* hook entry 0		*/
    "\x90\x90\x90\x90\x90"	/* hook entry 1		*/
    "\x90\x90\x90\x90\x90"	/* hook entry 2		*/
    "\x90\x90\x90\x90\x90"	/* hook entry 3		*/
    "\x90\x90\x90\x90\x90"	/* hook entry 4		*/
    "\x90\x90\x90\x90\x90"	/* hook entry 5		*/
    "\x90\x90\x90\x90\x90"	/* hook entry 6		*/
    "\x90\x90\x90\x90\x90"	/* hook entry 7		*/
    "\x83\xC4\x04"		/* addl $0x04, %esp	*/

    "\x4C"			/* dec %esp		*/
    "\xEB\x14"			/* jmp end		*/
    "\x5E"			/* begin: pop %esi	*/
    "\x8B\x44\x24\x05"		/* movl 5(%esp), %eax	*/
    "\x89\x46\x14"		/* movl %eax, 20(%esi)	*/
    "\x89\x74\x24\x05"		/* movl %esi, 5(%esp)	*/ 
    "\x44"			/* inc %esp		*/
    "\xB8\x00\x00\x00\x00"	/* movl $0x00, %eax	*/
				/* 3RD RELOCATION (hijack_me() + 3, absolute) */
    "\xFF\xE0"			/* jmp *%eax		*/
    "\xE8\xE7\xFF\xFF\xFF"	/* end: call begin	*/
    
    "\xBE\x00\x00\x00\x00"	/* movl $0x00, %esi	*/
				/* 4TH RELOCATION (&voodoo_bytes[0], absolute) */
    "\xBF\x00\x00\x00\x00"	/* movl $0x00, %edi */
				/* 5TH RELOCATION (hijack_me() + 3, absolute) */
    "\x1E"			/* push %ds		*/
    "\x07"			/* pop  %es		*/
    "\xFC"			/* cld			*/
    "\x31\xC9"			/* xor %ecx, %ecx	*/
    "\xB1\x07"			/* movl $0x07, %cl	*/
    "\xF3\xA4"			/* rep movsb		*/

    "\xB9\x00\x00\x00\x00"	/* movl $0x00, %ecx	*/
    "\x51"			/* pushl %ecx		*/
    "\xC3";			/* ret			*/

  if(uhook_t == NULL) {
		QUIT("MALLOC:");
  }
  memset(uhook_t,0,sizeof(uhook_t));

  /*
  ** Allocate space and resolve the symbol .
  */
  kkmalloc(sizeof(hook_t), (unsigned long *)&(uhook_t->addr_h));
  if (!uhook_t->addr_h)
    QUIT("kmalloc");
  
  if (!hooked)
    {
      kkfree(uhook_t->addr_h);
      QUIT("[DEBUG] kernel_hook_set: Cant resolve hijacked symbol .\n");
    }
  uhook_t->h.addr = hooked;


  /*
  ** Fill the hijacked_bytes field (aka constructing the indirect jump)
  */
  uhook_t->h.voodoo_bytes[0] = MOV_EAX;
  *(int *) &(uhook_t->h.voodoo_bytes[1]) = (int) uhook_t->addr_h + (int)((unsigned long)&uhook_t->h.hook - (unsigned long)&uhook_t->h );
  uhook_t->h.voodoo_bytes[5] = IJMP1;
  uhook_t->h.voodoo_bytes[6] = IJMP2;

  
  /*
  ** Guess if the hijacked function has a stack frame 
  */
  if(read_kmem(buf, uhook_t->h.addr, sizeof(buf), file_descriptor_kmem) == 0 ) {
	  tmp = memcmp((char *) buf,
		       STACKFRAME_CONSTANT,
			   STACKFRAME_CONSTANT_SIZE);
	  uhook_t->h.offset = (!tmp ? STACKFRAME_CONSTANT_SIZE : 0);
  } else {
	  QUIT("Unable to read the address !\n");
  }

  
  /*
  ** If the function doesnt have a stackframe, patch three bytes
  ** in the hookcode .
  */
  if (!uhook_t->h.offset)
    {
      hook_code[FIXUP_ONE]   = 0x04;
      hook_code[FIXUP_TWO]   = 0x01;
      hook_code[FIXUP_THREE] = 0x01;
    }
  
  
  /*
  ** filling the saved_bytes field (aka saving the 7 overwritten bytes 
  ** of the function)
  */
  memcpy(uhook_t->h.saved_bytes, /*(void *) hooked*/buf + uhook_t->h.offset, sizeof(uhook_t->h.saved_bytes));


  /*
  ** setting the hook code and calculating relocation offsets .
  */
  
  memcpy(uhook_t->h.hook, hook_code, sizeof(hook_code));
  
  *(int *) &(uhook_t->h.hook[REL_OFFSET_ONE])   = (int) (uhook_t->addr_h + ((unsigned int)&uhook_t->h.saved_bytes - (unsigned int)&uhook_t->h));
  *(int *) &(uhook_t->h.hook[REL_OFFSET_TWO])   = (int) uhook_t->h.addr + 
														uhook_t->h.offset;
  *(int *) &(uhook_t->h.hook[REL_OFFSET_THREE]) = (int) uhook_t->h.addr + 
														uhook_t->h.offset;
  *(int *) &(uhook_t->h.hook[REL_OFFSET_FOUR])  = (int) (uhook_t->addr_h + ((unsigned int)&uhook_t->h.voodoo_bytes - (unsigned int)&uhook_t->h));
  *(int *) &(uhook_t->h.hook[REL_OFFSET_FIVE])  = (int) uhook_t->h.addr + 
														uhook_t->h.offset;


  /*
  ** Creating the caches used for aggressive mode
  */
  memcpy(uhook_t->h.cache1, &(uhook_t->h.hook[CACHE1_OFFSET]), CACHE1_SIZE);
  memcpy(uhook_t->h.cache2, &(uhook_t->h.hook[CACHE2_OFFSET]), CACHE2_SIZE);

  /*
  ** Setting the hook parameters (This will write it in memory)
  */
  if (lkh_khook_set_attr(uhook_t, mask) < 0)
    {
      kkfree(uhook_t->addr_h);
	  free(uhook_t);
      QUIT("kernel_set_attr: invalid mask \n");
    }

  return (uhook_t);
}

/*
** Front end for khook_set_type, khook_set_state and khook_set_mode
*/
int	lkh_khook_set_attr(struct Uhook_t *h, int mask)
{
  if ((mask & HOOK_ENABLED) && (mask & HOOK_DISABLED))
    return (-1);
  if ((mask & HOOK_SINGLESHOT) && (mask & HOOK_PERMANENT))
    return (-1);
  if ((mask & HOOK_AGGRESSIVE) && (mask & HOOK_DISCRETE))
    return (-1);

  if (mask & HOOK_SINGLESHOT)
    lkh_khook_set_type(&h->h, HOOK_SINGLESHOT);
  else if (mask & HOOK_PERMANENT)
    lkh_khook_set_type(&h->h, HOOK_PERMANENT);
  
  if (mask & HOOK_AGGRESSIVE)
    lkh_khook_set_mode(&h->h, HOOK_AGGRESSIVE);
  else if (mask & HOOK_DISCRETE)
    lkh_khook_set_mode(&h->h, HOOK_DISCRETE);

  /*
  ** write it !!!
  */
  wr_memcpy((char *)h->addr_h,(char *)&h->h,sizeof(h->h));
	
  if (mask & HOOK_ENABLED)
    lkh_khook_set_state(&h->h, HOOK_ENABLED);
  else if (mask & HOOK_DISABLED)
    lkh_khook_set_state(&h->h, HOOK_DISABLED);
  
  return (0);
}

/*
** Change the hook type (HOOK_SINGLESHOT or HOOK_PERMANENT)
*/
int	lkh_khook_set_type(hook_t *h, char type)
{

  /* overwrite the 10 first byte with an indirect jump */
  if (type == HOOK_PERMANENT) 
    {
      memcpy(h->hook + HOOK_CONSTANT1_OFFSET,
	     HOOK_CONSTANT1,
	     HOOK_CONSTANT1_SIZE);
      return (0);
    }
  else if (type == HOOK_SINGLESHOT)
    {
      memset(h->hook + HOOK_CONSTANT1_OFFSET,
	     NOP,
	     HOOK_CONSTANT1_SIZE);
      return (0);
    }

  /* The requested type is invalid */
  return (-1);

}

/*
** Say whether or not the hijacked function will be called after
** the callback functions .
*/
int		lkh_khook_set_mode(hook_t *h, char mode)
{

  if (mode == HOOK_AGGRESSIVE)
    {
      memset(&h->hook[CACHE1_OFFSET], NOP, CACHE1_SIZE);
      memset(&h->hook[CACHE2_OFFSET], NOP, CACHE2_SIZE);
      if (h->offset)
		h->hook[CACHE2_OFFSET] = LEAVE;
      return (0);
    }
  else if (mode == HOOK_DISCRETE)
    {
      memcpy(&h->hook[CACHE1_OFFSET], h->cache1, CACHE1_SIZE);
      memcpy(&h->hook[CACHE2_OFFSET], h->cache2, CACHE2_SIZE);
      return (0);
    }

  /* Incorrect mode */
  return (-1);

}

/*
** Enable/Disable a hook (it's enabled by default)
*/
int	lkh_khook_set_state(hook_t *h, char state)
{

  /*
  ** Enable the hook
  */
  if (state == HOOK_ENABLED)
    {
      wr_memcpy((char *) h->addr + h->offset,
	     h->voodoo_bytes,
	     sizeof(h->voodoo_bytes));
      return (0);
    }

  /*
  ** Disable the hook
  */
  else if (state == HOOK_DISABLED)
    {
      wr_memcpy((char *) h->addr + h->offset,
	     h->saved_bytes,
	     sizeof(h->saved_bytes));	
      return (0);
    }

  /*
  ** The requested state is invalid 
  */
  return (-1);

}

struct Uhook_t *
lkh_khook_get(size_t addr) {
	/* We just need to malloc and readin memory :/ */
	struct Uhook_t *uhook_t= (struct Uhook_t *)malloc(sizeof(struct Uhook_t));

	/* now read it */
	uhook_t->addr_h = addr;
	if ( read_kmem(&(uhook_t->h),uhook_t->addr_h,sizeof(uhook_t->h),
			file_descriptor_kmem) < 0) {
		perror("lkh_hook_get : read_kmem");
		return NULL;
	}
	/* We can try to do basic checks here ? */
	return uhook_t;
}

void
lkh_khook_list_callback( struct Uhook_t * h ) 
{
	int i = 0;
	fprintf(stdout,"Listing callbacks for %#08x (function : %#08x): \n",
					h->addr_h,h->h.addr);
	for ( i = 0; i < 8; i++ ) {
		if (*(char*)&(h->h.hook[INTRO_CODE_SIZE + i * 5]) == '\x90') {
			fprintf(stdout," %d : No hook\n",i);
		} else {
			fprintf(stdout," %d : %#08x\n",i,h->addr_h +((int)&h->h.hook - (int)&h->h) + INTRO_CODE_SIZE + (i+1) * 5 + *(int*)&(h->h.hook[INTRO_CODE_SIZE + i * 5 + 1]));
		}
	}
}

void
advanced_usage( void )
{
	fprintf(stdout,
			"Well, you want to hijack some functions, nice idea, lot's of\n"
			"purpose ;). But you need to be warned : this hooking technique\n"
			"is DANGEROUS, depends on which kind of function you plan to\n"
			"use. When testing this implementation, I found some cases where\n"
			"the dIscrete mode produces a lot's of OOPS :/. I don't know  if\n"
			"it is due to the technique itself, or some bugs in gcc.\n"
			"Anyway, I think that you can use this hooking for many syscall\n"
		   	"functions - safely -. If you plan to test with no user mode \n"
			"functions, then create a module reproducing exactly the function\n"
			"you intend to hijack (simply copy the sources dude :), and try\n"
			"to work against this module function (use your brain and kernsh)\n"
			"So you will be able to restore it anytime it will be corrupted :)\n"
		   );
	if ( !script_on_command_line ) {
		fprintf(stderr,"Press a Key to continue\n");
		getchar();
	}
	fprintf(stdout,
			"\nOk, short example :\n"
			"Find the symbol address :\n"
			"%% symbol -q sys_fork\n"
			"Create the hook :\n"
			"%% lhook -c 0xc01075f0 -n 0\n"
			"[NOTE : the order of arguments doesn't matter]\n"
			"Add a callback to the hook (ie a function called from the hook\n"
			"%% lhook -n 0 -a <address_of_callback> 0\n"
			"[NOTE : You have 8 callbacks possible from 0 to 7 :)]\n"
			"Add a second callback ...\n"
			"%% lhook -a <address_of_2th_callback> 4 -n 0\n"
			"etc ... use your brain\n"
			"\nYou can purge (remove all callbacks), or remove one callback\n"
			"you need to destroy a callback (hook -d -n 0) to liberate memory\n"
			"and removing the callback\n"
		   );
	if ( !script_on_command_line ) {
		fprintf(stderr,"Press a Key to continue\n");
		getchar();
	}
	fprintf(stdout,
			"\nLast but not least, the hook mode (option -c -m / -s -m)\n"
			"The mode are 3 x 2 and mutually exclusive\n"
			"\tENABLE : DISABLE => no comment\n"
			"\tAGGRESSIVE : DISCRETE => AGG = no call to the hijacked function\n"
			"\tPERMANENT : SINGLE SHOT => SINGLE SHOT = one time hijacking\n"
			"\nI hope that all is clear, if not read the Mayhem work !\n" 
		   );
}

void
usage_lhook( void )
{
    usage_t p_usage;

    p_usage.command_line =
		"lhook [ nmcarpdlgH ] <arguments>";
    p_usage.description =
		"This command let you create hooks functions. There are more visible than the\n"
		"kmem -h option. See the doc to understand why.\n"
		"PLEASE use the -H option to see important notes !!!";		
    p_usage.arguments =
		"  -n <slot #> : play with this slot number < SLOT_MAX\n" 
		"  -c <address to hook> : create the hook slot for"
		" the <address to hook>\n"
		"  -a <callback> <position> : add a callback to the hook in <position> < 7\n"
		"  -r <position> : remove a callback to the hook in <position> < 8\n"
		"  -p : purge all callbacks to the hook\n"
		"  -l : list all the callbacks of a hook\n"
		"  -s : modify the mode of an already existing hook !\n"
		"  -m [e|d][a|i][p|s] : set the mode of the hook : (with -s or -c)\n"
		"        e : enable\td : disable\n"
		"        a : agressive\ti : discrete\n"
		"        p : permanent hook\ts : single shot\n"
		"        ^\\default\n"
		"  -d : delete a hook (remove completly)\n"
		"  -g <address_of_hook> : get a hook in memory at <address_of_hook>\n"
		"(In case kernsh just segfault, this permit you to work again on the hook)\n"
		"  -H : Some help about all this :)\n"
		"In ALL case (apart -H) use the -n option to specify the hook";

    usage( &p_usage );
    return;
}

void
do_lhook( int pargc, char * pargv[] )
{
	char c;
	size_t create = 0;
	size_t get  = 0;
	size_t add[8];
	int remove[8];
	int pos = -1;
	int delete = 0;
	int mode = 0;
	int num_char = 0;
	int i = 0;
	int purge = 0;
	int list = 0;
	int attr = 0;
	
	NOARGUMENTS( pargc, 1, lhook);

	memset(add,0,sizeof(add));
	memset(remove,0,sizeof(remove));	
	optind = 0;
	
	while( (c = getopt(pargc, pargv, "lspdn:c:a:r:m:Hg:x")) != EOF ) {
		switch( c ) {
			case 'x':
				/* This is not documented on purpose ;) */
				if ( debug_hook == 0 ) {
					fprintf(stdout,"debug hook on\n");
					debug_hook++;
				} else {
					fprintf(stdout,"debug hook off\n");
					debug_hook--;
				}
				return;
			case 'H':
				advanced_usage();
				return;
			case 'g':
				XSTRTOUL(optarg,get);
				break;
			case 's':
				attr = 1;
				break;
			case 'l':
				list = 1;
				break;
			case 'p':
				purge = 1;
				break;
			case 'r':
				i = atoi(optarg);
				if( i > 7 || i < 0 ) {
					fatal("Invalid position !\n");
					return;
				} else {
					remove[i] = 1;
				}
				break;
			case 'm':
				num_char = strlen(optarg);
				for(i = 0; i < num_char; i++) {
					switch(optarg[i]) {
						case 'e' :
							mode |= HOOK_ENABLED;
							break;
						case 'd' :
							mode |= HOOK_DISABLED;
							break;
						case 'a' :
							mode |= HOOK_AGGRESSIVE;
							break;
						case 'i' :
							mode |= HOOK_DISCRETE;
							break;
						case 'p' :
							mode |= HOOK_PERMANENT;
							break;
						case 's' :
							mode |= HOOK_SINGLESHOT;
							break;
						default :
							usage_hook();
							return;
					}
				}
				break;
			case 'a':
				if (pargv[optind] == NULL || pargv[optind][0]=='-') {
					usage_hook();
					return;
				}
				pos = atoi(pargv[optind]);
				if ( pos > 7 || pos < 0 ) {
					fatal("Invalid position\n");
					return;
				}
				XSTRTOUL(optarg,add[pos]);
				break;
			case 'd':
				delete = 1;
				break;
			case 'n':
				num_slot = atoi(optarg);
				if( num_slot >  SLOT_MAX || num_slot < 0) {
					fatal("Invalid slot number of hook !\n");
					return;
				}
				break;
			case 'c':
				XSTRTOUL(optarg, create);
				break;
			default:
				return;
		}
	}

	/* Processing the hooking ! */
	if ( num_slot == -1 ) {
		usage_hook();
		return;
	}
	
	if ( create != 0 && num_char != 3 ) {
		fprintf(stdout,"Defaulting the values for the mode\n");
		if ( !(mode & HOOK_ENABLED) && !(mode & HOOK_DISABLED) ) {
			mode |= HOOK_ENABLED;
		}
		if ( !(mode & HOOK_AGGRESSIVE) && !(mode & HOOK_DISCRETE) ) {
			mode |= HOOK_AGGRESSIVE;
		}
		if ( !(mode & HOOK_PERMANENT) && !(mode & HOOK_SINGLESHOT) ) {
			mode |= HOOK_PERMANENT;
		}
	}
	
	/* Create Callback */
	if ( create != 0 ) {
		if ( slot_hook[num_slot] != NULL ) {
			fprintf(stdout,"Already created slot n°%d\n",num_slot);
			return;
		} else {
			slot_hook[num_slot] = (struct Slot_hook*)
				malloc(sizeof(slot_hook[num_slot]));
		}
		(slot_hook[num_slot])->hook = lkh_khook_create(create,mode);
		if ( (slot_hook[num_slot])->hook == NULL ) {
			fatal("Failed to create the hook, gave up !\n");
			return;
		}
		/* Or get it from memory */
	} else if ( get != 0 ) {
		if ( slot_hook[num_slot] != NULL ) {
			fprintf(stdout,"Already created slot n°%d\n",num_slot);
			return;
		} else {
			slot_hook[num_slot] = (struct Slot_hook*)
				malloc(sizeof(slot_hook[num_slot]));
		}	
		(slot_hook[num_slot])->hook = lkh_khook_get(get);
		if ( (slot_hook[num_slot])->hook == NULL ) {
			fatal("Failed to get the hook, gave up !\n");
			return;
		}
	}
	
	/* All operation after take place in builded hook ! */
	if( slot_hook[num_slot] == NULL ) {
			fatal("You must create your hook first !\n");
			return;
	}

	/* modify the mode of the callback ? */
	if ( attr == 1) {
		if ( -1 == lkh_khook_set_attr(slot_hook[num_slot]->hook, mode) ) {
			fatal("Invalid mode !!\n");
			return;
		}
	}
	
	/* Adding callbacks */	
	if ( pos < 7 && pos > -1 ) {
		for ( i = 0; i < 8; i++ ) {
			if ( add[i] != 0 ) {
				if ( 0 == lkh_khook_add_entry(slot_hook[num_slot]->hook, 
									(int)add[i], i)) {
				} else {
					fatal("Failed to add a callback %d !\n",i);
				}
			}
		}
	}
	
	/* list callbaks */
	if ( list == 1)	{
		lkh_khook_list_callback(slot_hook[num_slot]->hook);
	}
	
	/* remove callbacks */
	for ( i = 0; i < 8; i++ ) {
		if ( remove[i] == 1 ) {
			lkh_khook_remove_entry(slot_hook[num_slot]->hook, i);
		}
	}
	
	/* purge callbacks */
	if ( purge == 1 ) {
		lkh_khook_purge(slot_hook[num_slot]->hook);
	}
	
	/* destroy a hook */
	if ( delete != 0 ) {
		if ( slot_hook[num_slot] != NULL) {
			lkh_khook_destroy(slot_hook[num_slot]->hook);
			free(slot_hook[num_slot]);
		}
		slot_hook[num_slot] = NULL;
	}
	
	num_slot = -1;
}
